import * as DailyRotateFile from 'winston-daily-rotate-file';
import { LogLevel } from '@nestjs/common';
import { Request } from 'express';
import { HttpTransportOptions } from './http';
declare const defauleLogEntries: readonly ["timestamp", "level", "context", "message", "trace", "ip", "ua", "method", "url", "query", "body"];
export type ConstructOptions = DailyRotateFile.DailyRotateFileTransportOptions & {
    context?: string;
    level?: LogLevel;
    logEntries?: LogEntry[];
    http?: HttpTransportOptions;
};
export type LogEntry = (typeof defauleLogEntries)[number];
export interface LoggerContext {
    context?: string;
    ip?: string;
    ua?: string;
    method?: string;
    url?: string;
    query?: any;
    body?: any;
    [name: string]: any;
}
export declare class Logger {
    private context?;
    private loggers;
    private level;
    private logEntries;
    constructor(options: ConstructOptions, context?: LoggerContext | undefined);
    static getContext(context: string | {
        context?: string;
        [name: string]: any;
    }, request: Request): LoggerContext;
    all(message: any, level: LogLevel, context?: LoggerContext, trace?: string): any;
    setLevel(level?: LogLevel): void;
    error(message: any, trace?: string, context?: LoggerContext): void;
    log(message: any, context?: LoggerContext): void;
    warn(message: any, context?: LoggerContext): void;
    debug(message: any, context?: LoggerContext): void;
    verbose(message: any, context?: LoggerContext): void;
}
export {};
